Package com.saxonica.ee.domino

## Class DominoTreeModel

- java.lang.Object
- - net.sf.saxon.om.TreeModel
  - - com.saxonica.ee.domino.DominoTreeModel

- All Implemented Interfaces:
    `ExternalObjectModel`

      public class DominoTreeModel
      extends TreeModel
      implements ExternalObjectModel

  Tree model implementation for the DOMINO tree

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `DominoTreeModel.DominoBuilder` | A Builder class for the Domino tree model

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.om.TreeModel

      `LINKED_TREE, TINY_TREE, TINY_TREE_CONDENSED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DominoTreeModel()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Receiver` | `getDocumentBuilder​(javax.xml.transform.Result result)` | Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events.
    `java.lang.String` | `getDocumentClassName()` | Get the name of a characteristic class, which, if it can be loaded, indicates that the supporting libraries for this object model implementation are available on the classpath
    `java.lang.String` | `getIdentifyingURI()` | Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation
    `static DominoTreeModel` | `getInstance()` |
    `JPConverter` | `getJPConverter​(java.lang.Class sourceClass, Configuration config)` | Get a converter from values in the external object model to XPath values.
    `java.lang.String` | `getName()` | Get a name that identifies the tree model
    `PJConverter` | `getNodeListCreator​(java.lang.Object node)` | Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.
    `PJConverter` | `getPJConverter​(java.lang.Class<?> targetClass)` | Get a converter from XPath values to values in the external object model
    `int` | `getSymbolicValue()` | Get the integer constant used to identify this tree model in some legacy interfaces
    `Builder` | `makeBuilder​(PipelineConfiguration pipe)` | Make a Builder, which can then be used to construct an instance of this tree model from a stream of events
    `boolean` | `sendSource​(javax.xml.transform.Source source, Receiver receiver)` | Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true.
    `NodeInfo` | `unravel​(javax.xml.transform.Source source, Configuration config)` | Wrap or unwrap a node using this object model to return the corresponding Saxon node.

    - ### Methods inherited from class net.sf.saxon.om.TreeModel

      `getTreeModel, isMutable, isSchemaAware`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DominoTreeModel

          public DominoTreeModel()

  - ### Method Detail

    - #### getInstance

          public static DominoTreeModel getInstance()

    - #### getDocumentClassName

          public java.lang.String getDocumentClassName()

      Get the name of a characteristic class, which, if it can be loaded, indicates that the supporting libraries for this object model implementation are available on the classpath
      Specified by:
        `getDocumentClassName` in interface `ExternalObjectModel`
      Returns:
        by convention (but not necessarily) the class that implements a document node in the relevant external model

    - #### getIdentifyingURI

          public java.lang.String getIdentifyingURI()

      Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation
      Specified by:
        `getIdentifyingURI` in interface `ExternalObjectModel`
      Returns:
        the URI used to identify this object model in the JAXP XPath factory mechanism.

    - #### makeBuilder

          public Builder makeBuilder​(PipelineConfiguration pipe)

      Description copied from class: `TreeModel`
      Make a Builder, which can then be used to construct an instance of this tree model from a stream of events
      Specified by:
        `makeBuilder` in class `TreeModel`
      Parameters:
        `pipe` - A PipelineConfiguration, which can be constructed using the method `Configuration.makePipelineConfiguration()`.
      Returns:
        a newly created Builder

    - #### getSymbolicValue

          public int getSymbolicValue()

      Description copied from class: `TreeModel`
      Get the integer constant used to identify this tree model in some legacy interfaces
      Overrides:
        `getSymbolicValue` in class `TreeModel`
      Returns:
        an integer constant used to identify the model, for example `Builder.TINY_TREE`

    - #### getName

          public java.lang.String getName()

      Description copied from class: `TreeModel`
      Get a name that identifies the tree model
      Overrides:
        `getName` in class `TreeModel`
      Returns:
        an identifying name for the tree model

    - #### sendSource

          public boolean sendSource​(javax.xml.transform.Source source,
                                    Receiver receiver)
                             throws XPathException

      Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true. Otherwise, return false.
      Specified by:
        `sendSource` in interface `ExternalObjectModel`
      Parameters:
        `source` - a JAXP Source object
        `receiver` - the Receiver that is to receive the data from the Source. The caller is responsible for opening and closing the receiver.
      Returns:
        true if the data from the Source has been sent to the Receiver, false otherwise
      Throws:
        `XPathException` - if any failure occurs

    - #### getDocumentBuilder

          public Receiver getDocumentBuilder​(javax.xml.transform.Result result)
                                      throws XPathException

      Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events. If the Result is not recognised, return null.

      This implementation always returns null (the Domino model is never used for transformation or query results)

      Specified by:
        `getDocumentBuilder` in interface `ExternalObjectModel`
      Parameters:
        `result` - a JAXP result object
      Returns:
        a Receiver that writes to that result, if available; or null otherwise
      Throws:
        `XPathException` - if any failure occurs

    - #### getPJConverter

          public PJConverter getPJConverter​(java.lang.Class<?> targetClass)

      Get a converter from XPath values to values in the external object model
      Specified by:
        `getPJConverter` in interface `ExternalObjectModel`
      Parameters:
        `targetClass` - the required class of the result of the conversion. If this class represents a node or list of nodes in the external object model, the method should return a converter that takes a native node or sequence of nodes as input and returns a node or sequence of nodes in the external object model representation. Otherwise, it should return null.
      Returns:
        a converter, if the targetClass is recognized as belonging to this object model; otherwise null

    - #### getJPConverter

          public JPConverter getJPConverter​(java.lang.Class sourceClass,
                                            Configuration config)

      Get a converter from values in the external object model to XPath values.
      Specified by:
        `getJPConverter` in interface `ExternalObjectModel`
      Parameters:
        `sourceClass` - the class (static or dynamic) of values to be converted
        `config` -
      Returns:
        a converter, if the sourceClass is recognized as belonging to this object model; otherwise null

    - #### getNodeListCreator

          public PJConverter getNodeListCreator​(java.lang.Object node)

      Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.

      This method is primarily for the benefit of DOM, which uses its own NodeList class to represent collections of nodes. Most other object models use standard Java collection objects such as java.util.List

      Specified by:
        `getNodeListCreator` in interface `ExternalObjectModel`
      Parameters:
        `node` - an example of the kind of node used in this model
      Returns:
        if the model does not recognize this node as one of its own, return null. Otherwise return a PJConverter that takes a list of XPath nodes (represented as NodeInfo objects) and returns a collection of nodes in this object model

    - #### unravel

          public NodeInfo unravel​(javax.xml.transform.Source source,
                                  Configuration config)

      Wrap or unwrap a node using this object model to return the corresponding Saxon node. If the supplied source does not belong to this object model, return null
      Specified by:
        `unravel` in interface `ExternalObjectModel`
      Parameters:
        `source` - a JAXP Source object
        `config` - the Saxon configuration
      Returns:
        a NodeInfo corresponding to the Source, if this can be constructed; otherwise null